//+------------------------------------------------------------------+
//|                                         WinKernel32.mqh          |
//|                                         Copyright  Zhunko       |
//|21.12.2007                               MF ZHUNKO zhunko@mail.ru |
//+------------------------------------------------------------------+
//|  WinAPI - -   -                  |
//|  http://books.kulichki.ru/data/api/api1/index0.htm               |
//+------------------------------------------------------------------+

//
//====    "dwCreationFlags"  "CreateProcessA()". ==============================================================================================================================================================
#define CREATE_BREAKAWAY_FROM_JOB        0x01000000 //        .      ,     .
                                                    //     ,     JOB_OBJECT_LIMIT_BREAKAWAY_OK.
#define CREATE_DEFAULT_ERROR_MODE        0x04000000 //        . ,      . 
                                                    //      -  ,        .
                                                    //   -        .    ,    .
#define CREATE_NEW_CONSOLE               0x00000010 //     ,     ().  ,   . 
                                                    //       DETACHED_PROCESS.
#define CREATE_NEW_PROCESS_GROUP         0x00000200 //        .     ,  -    .
                                                    //           ,     lpProcessInformation.
                                                    //     GenerateConsoleCtrlEvent,     CTRL+BREAK    .
                                                    //    ,  CTRL+C            .
                                                    //      CREATE_NEW_CONSOLE.
#define CREATE_NO_WINDOW                 0x08000000 //    ,  -    .      .
                                                    //      -   ,      CREATE_NEW_CONSOLE  DETACHED_PROCESS.
#define CREATE_PROTECTED_PROCESS         0x00040000 //       .          .
                                                    //    ,      ,        .
                                                    //    ,      .        
                                                    //    -  .       :  ,  ,  
                                                    // Windows,  . ,         .
                                                    //           .  ,     .
                                                    // Windows  2003  Windows XP/2000:    .
#define CREATE_PRESERVE_CODE_AUTHZ_LEVEL 0x02000000 //   ,    ,    ,       .
                                                    // Windows 2000:    .
#define CREATE_SEPARATE_WOW_VDM          0x00000800 //   -      16-    Windows.  ,       Virtual DOS (VDM).
                                                    //  ,  16-    Windows     ,  VDM.
                                                    //    - ,      VDM;   ,    VDMs 
                                                    //  . , 16-    Windows,  -    VDMs    .
                                                    //  ,        ,    VDMs   .
                                                    //    - ,      ,   .        
                                                    // ,  16-        VDM.
#define CREATE_SHARED_WOW_VDM            0x00001000 //  -      16-    Windows.  DefaultSeparateVDM   Windows WIN.INI  ,
                                                    //    .        Virtual DOS.
#define CREATE_SUSPENDED                 0x00000004 //               ResumeThread   .
#define CREATE_UNICODE_ENVIRONMENT       0x00000400 //    ,   ,  lpEnvironment   .   ,     ANSI.
#define DEBUG_ONLY_THIS_PROCESS          0x00000002 //       .       ,   WaitForDebugEvent.
#define DEBUG_PROCESS                    0x00000001 //              .       ,   WaitForDebugEvent. 
                                                    // ,   DEBUG_PROCESS    .           DEBUG_PROCESS.
                                                    //     DEBUG_ONLY_THIS_PROCESS,      ,    .
#define DETACHED_PROCESS                 0x00000008 //   ,        (  ).      AllocConsole ,
                                                    //   .  ,   .       CREATE_NEW_CONSOLE.
#define EXTENDED_STARTUPINFO_PRESENT     0x00080000 //     ;  lpStartupInfo   STARTUPINFOEX.
                                                    // Windows  2003  Windows XP/2000:    .
#define INHERIT_PARENT_AFFINITY          0x00010000 //     .       ,    ,   
                                                    // -      .
                                                    // Windows  2008, Windows , Windows  2003,  Windows XP/2000:    .
//====    . ===================================================================================================================================================================================================
#define CREATE_NEW                   1
#define CREATE_ALWAYS                2
#define OPEN_EXISTING                3
#define OPEN_ALWAYS                  4
#define FILE_SHARE_READ              0x0001
#define FILE_SHARE_WRITE             0x0002
#define FILE_MAP_WRITE               0x0002
#define FILE_MAP_READ                0x0004
#define GENERIC_READ                 0x80000000
#define GENERIC_WRITE                0x40000000
#define PAGE_READONLY                0x0002
#define PAGE_READWRITE               0x0004
//====    "_lopen()". =================================================================================================================================================================================================
                                                // ----  "iReadWrite".------------------------------------------------------------------------------------------------------------------------------------------------------------
#define OF_READ_                     0          //     
#define OF_WRITE_                    1          //     
#define OF_READWRITE_                2          //     /
#define OF_SHARE_COMPAT_             3          //       .            .         ,   HFILE_ERROR.
#define OF_SHARE_DENY_NONE_          4          //          /  .        OF_SHARE_COMPAT,   HFILE_ERROR.
#define OF_SHARE_DENY_READ_          5          //            .        OF_SHARE_COMPAT / OF_READ  OF_READWRITE,   HFILE_ERROR.
#define OF_SHARE_DENY_WRITE_         6          //            .        OF_SHARE_COMPAT / OF_READ  OF_READWRITE,   HFILE_ERROR.
#define OF_SHARE_EXCLUSIVE_          7          //             /.          ( ).       .
//====    "CreateFile()". =============================================================================================================================================================================================
                                                // ----  "dwDesiredAccess". ------------------------------------------------------------------------------------------------------------------------------------------------------
#define GENERIC_EXECUTE              0x20000000 //    .
#define GENERIC_WRITE                0x40000000 //     .
#define GENERIC_READ                 0x80000000 //     .
                                                // ----     "dwDesiredAccess". -------------------------------------------------------------------------------------------------------------------------
#define FILE_ADD_FILE                0x0002     //  ,     .
#define FILE_ADD_SUBDIRECTORY        0x0004     //  ,   subdirectory.
//#define FILE_ALL_ACCESS                         //      .
#define FILE_APPEND_DATA             0x0004     //   ,     .
#define FILE_CREATE_PIPE_INSTANCE    0x0004     //   ,   .
#define FILE_DELETE_CHILD            0x0040     //  ,      ,   ,     .
#define FILE_EXECUTE                 0x0020     //    ,   .        ,   ,     .
#define FILE_LIST_DIRECTORY          0x0001     //  ,    .
#define FILE_READ_ATTRIBUTES         0x0080     //    .
#define FILE_READ_DATA               0x0001     //   ,     .   ,     .
#define FILE_READ_EA                 0x0008     //     .
#define FILE_TRAVERSE                0x0020     //  ,   .  ,    BYPASS_TRAVERSE_CHECKING,     FILE_TRAVERSE.
#define FILE_WRITE_ATTRIBUTES        0x0100     //    .
#define FILE_WRITE_DATA              0x0002     //   ,     .   ,      (FILE_ADD_FILE).
#define FILE_WRITE_EA                0x0010     //     .
//#define STANDARD_RIGHTS_READ                    //  READ_CONTROL,  -          .      SACL.
//#define STANDARD_RIGHTS_WRITE      0x00000000   // ,  STANDARD_RIGHTS_READ.
#define SYNCHRONIZE                  0x00100000 //         .
                                                // ----  "dwShareMode". ----------------------------------------------------------------------------------------------------------------------------------------------------------
#define FILE_SHARE_NO                0x00000000 //    .
#define FILE_SHARE_READ              0x00000001 //          .
#define FILE_SHARE_WRITE             0x00000002 //          .
#define FILE_SHARE_DELETE            0x00000004 //          . 
                                                // ----  "dwCreationDisposition".-------------------------------------------------------------------------------------------------------------------------------------------------
#define CREATE_NEW                   1          //   ,    .
#define CREATE_ALWAYS                2          //   , .
#define OPEN_EXISTING                3          //    ,   .
#define OPEN_ALWAYS                  4          //  , .
#define TRUNCATE_EXISTING            5          //        -  ,    .
                                                // ----  "dwFlagsAndAttributes". -------------------------------------------------------------------------------------------------------------------------------------------------
                                                // ---- . -------------------------------------------------------------------------------------------------------------------------------------------------------------------------
#define FILE_ATTRIBUTE_READONLY      0x1        //    (1)   .    ,        .
#define FILE_ATTRIBUTE_HIDDEN        0x2        //    (2)  .       .
#define FILE_ATTRIBUTE_SYSTEM        0x4        //    (4)        .
#define FILE_ATTRIBUTE_ARCHIVE       0x20       //   (32)    .    ,       .
#define FILE_ATTRIBUTE_NORMAL        0x80       //  (128)      .   -      .
#define FILE_ATTRIBUTE_TEMPORARY     0x100      //  (256)     .
#define FILE_ATTRIBUTE_OFFLINE       0x1000     // (4096)     .   ,       offline .
#define FILE_ATTRIBUTE_ENCRYPTED     0x4000     //(16384)    .
                                                // ---- . ----------------------------------------------------------------------------------------------------------------------------------------------------------------------------
#define FILE_FLAG_BACKUP_SEMANTICS   0x02000000 //         .
#define FILE_FLAG_DELETE_ON_CLOSE    0x04000000 //      .
#define FILE_FLAG_NO_BUFFERING       0x20000000 //      ,      .
#define FILE_FLAG_OPEN_NO_RECALL     0x00100000 //   ,        .
#define FILE_FLAG_OPEN_REPARSE_POINT 0x00200000 //  reparse    ; CreateFile   reparse .
#define FILE_FLAG_OVERLAPPED         0x40000000 //         /.
#define FILE_FLAG_POSIX_SEMANTICS    0x0100000  //     POSIX.
#define FILE_FLAG_RANDOM_ACCESS      0x10000000 //    .      ,    .
#define FILE_FLAG_SEQUENTIAL_SCAN    0x08000000 //      ,  .      ,    .
#define FILE_FLAG_WRITE_THROUGH      0x80000000 //        ,     .
//====    "CreateFileMappingA()". =====================================================================================================================================================================================
#define PAGE_EXECUTE                 0x10       //       .           .
#define PAGE_EXECUTE_READ            0x20       //   /    .         .
#define PAGE_EXECUTE_READWRITE       0x40       //  //     .
#define PAGE_EXECUTE_WRITECOPY       0x80       //   //    image   .     (read-on-write)
                                                //    (copy-on-write).
#define PAGE_NOACCESS                0x01       //       .    ,  ,     
                                                //   ,     (GP).
#define PAGE_READONLY                0x02       //       .         .   
                                                //        ,           .
#define PAGE_READWRITE               0x04       //   /    .
#define PAGE_WRITECOPY               0x08       //    (copy-on-write)     .
//====    "OpenFile()". ===============================================================================================================================================================================================
                                                // ----  "wStyle". ---------------------------------------------------------------------------------------------------------------------------------------------------------------
#define OF_CANCEL                    0x00000800 // .  ,    ,   ,  OF_PROMPT.
#define OF_CREATE                    0x00001000 //   .   ,     (0) .
#define OF_DELETE                    0x00000200 //  .
#define OF_EXIST                     0x00004000 //     .  ,     .
#define OF_PARSE                     0x00000100 //   OFSTRUCT,    - .
#define OF_PROMPT                    0x00002000 //        .
#define OF_READ                      0x00000000 //     .
#define OF_READWRITE                 0x00000002 //    / .
#define OF_REOPEN                    0x00008000 //        .
#define OF_SHARE_COMPAT              0x00000000 //    -DOS based,     ,      ,     .
#define OF_SHARE_DENY_NONE           0x00000040 //           .
#define OF_SHARE_DENY_READ           0x00000030 //         .
#define OF_SHARE_DENY_WRITE          0x00000020 //         .
#define OF_SHARE_EXCLUSIVE           0x00000010 //         /    .
//#define OF_VERIFY                               // ,             .         .
#define OF_WRITE                     0x00000001 //     .
//====    "WinExec()". ================================================================================================================================================================================================
                                                // ----  "nCmdShow".--------------------------------------------------------------------------------------------------------------------------------------------------------------
#define SW_HIDE	                              0 //      .
#define SW_SHOWNORMAL	                        1 //    .     ,        .
                                                //          .
#define SW_SHOWMINIMIZED	                    2 //        .
#define SW_SHOWMAXIMIZED	                    3 //        .
#define SW_MAXIMIZE	                          3 //   .
#define SW_SHOWNOACTIVATE	                    4 //         .      SW_SHOWNORMAL,  ,   .
#define SW_SHOW	                              5 //            .
#define SW_MINIMIZE	                          6 //           Z-.
#define SW_SHOWMINNOACTIVE	                  7 //       .      SW_SHOWMINIMIZED,  ,   .
#define SW_SHOWNA	                            8 //          .      SW_SHOW,  ,   .
#define SW_RESTORE	                          9 //      .     ,        .
                                                //          .
#define SW_SHOWDEFAULT	                     10 //   ,    SW_,    STARTUPINFO,    CreateProcess ,    .  
#define SW_FORCEMINIMIZE                     11 // Windows 2000/XP:  ,   ,   , .           .
//====  Windows. ===================================================================================================================================================================================================================
#define ERROR_SUCCESS                         0 //      .
#define ERROR_INVALID_FUNCTION                1 //  .
#define ERROR_FILE_NOT_FOUND	                2 //     .
#define ERROR_PATH_NOT_FOUND	                3 //     .
#define ERROR_TOO_MANY_OPEN_FILES             4 //     .
#define ERROR_ACCESS_DENIED                   5 //   .
#define ERROR_INVALID_HANDLE                  6 //   .
#define ERROR_ARENA_TRASHED                   7 //    .
#define ERROR_NOT_ENOUGH_MEMORY               8 //      .
#define ERROR_INVALID_BLOCK                   9 //      .
#define ERROR_BAD_ENVIRONMENT                10 //     .
#define ERROR_BAD_FORMAT	                   11 //  .EXE    (-Win32 .EXE     .EXE ).
#define ERROR_INVALID_ACCESS                 12 //   .
#define ERROR_INVALID_DATA                   13 //  .
#define ERROR_OUTOFMEMORY                    14 //      .
#define ERROR_INVALID_DRIVE                  15 //      .
#define ERROR_CURRENT_DIRECTORY              16 //     .
#define ERROR_NOT_SAME_DEVICE                17 //        .
#define ERROR_NO_MORE_FILES                  18 //   .
#define ERROR_WRITE_PROTECT                  19 //    .
#define ERROR_BAD_UNIT                       20 //      .
#define ERROR_NOT_READY                      21 //   .
#define ERROR_BAD_COMMAND                    22 //    .
#define ERROR_CRC                            23 //    (  ).
#define ERROR_BAD_LENGTH                     24 //       .
#define ERROR_SEEK                           25 //          .
#define ERROR_NOT_DOS_DISK                   26 //      .
#define ERROR_SECTOR_NOT_FOUND               27 //       .
#define ERROR_OUT_OF_PAPER                   28 // The printer is out of paper.    .
#define ERROR_WRITE_FAULT                    29 //        .
#define ERROR_READ_FAULT                     30 //       .
#define ERROR_GEN_FAILURE                    31 // ,   ,  .
#define ERROR_SHARING_VIOLATION              32 //       ,      .
#define ERROR_LOCK_VIOLATION                 33 //       ,       .
#define ERROR_WRONG_DISK                     34 //    . % 2 (  :% 3)  % 1.
#define ERROR_SHARING_BUFFER_EXCEEDED        36 //       .
#define ERROR_HANDLE_EOF                     38 //   .
#define ERROR_HANDLE_DISK_FULL               39 //  .
#define ERROR_NOT_SUPPORTED                  50 //   .
#define ERROR_REM_NOT_LIST                   51 // Windows     . ,             .    -     ,    .
#define ERROR_DUP_NAME                       52 //    ,      .     ,     ,       .     ,     .
#define ERROR_BAD_NETPATH                    53 //    .
#define ERROR_NETWORK_BUSY                   54 //  .
#define ERROR_DEV_NOT_EXIST                  55 //       .
#define ERROR_TOO_MANY_CMDS                  56 // The network BIOS command limit has been reached.   BIOS  .
#define ERROR_ADAP_HDW_ERR                   57 //    -  .
#define ERROR_BAD_NET_RESP                   58 //       .
#define ERROR_UNEXP_NET_ERR                  59 //    .
#define ERROR_BAD_REM_ADAP                   60 //    .
#define ERROR_PRINTQ_FULL                    61 //   .
#define ERROR_NO_SPOOL_SPACE                 62 //            .
#define ERROR_PRINT_CANCELLED                63 //   , .
#define ERROR_NETNAME_DELETED                64 //      .
#define ERROR_NETWORK_ACCESS_DENIED          65 //    .
#define ERROR_BAD_DEV_TYPE                   66 //     .
#define ERROR_BAD_NET_NAME                   67 //    .
#define ERROR_TOO_MANY_NAMES                 68 //         .
#define ERROR_TOO_MANY_SESS                  69 //      BIOS.
#define ERROR_SHARING_PAUSED                 70 //         .
#define ERROR_REQ_NOT_ACCEP                  71 //            ,           .
#define ERROR_REDIR_PAUSED                   72 //      .
#define ERROR_FILE_EXISTS                    80 //  .
#define ERROR_CANNOT_MAKE                    82 //       .
#define ERROR_FAIL_I24                       83 // Fail on INT 24.
#define ERROR_OUT_OF_STRUCTURES              84 //      .
#define ERROR_ALREADY_ASSIGNED               85 //     .
#define ERROR_INVALID_PASSWORD               86 //    .
#define ERROR_INVALID_PARAMETER              87 //   .
#define ERROR_NET_WRITE_FAULT                88 //     .
#define ERROR_NO_PROC_SLOTS                  89 //         .
#define ERROR_TOO_MANY_SEMAPHORES           100 //       . 
#define ERROR_EXCL_SEM_ALREADY_OWNED        101 //     .
#define ERROR_SEM_IS_SET                    102 //       .
#define ERROR_TOO_MANY_SEM_REQUESTS         103 //      .
#define ERROR_INVALID_AT_INTERRUPT_TIME     104 //       .
#define ERROR_SEM_OWNER_DIED                105 //      .
#define ERROR_SEM_USER_LIMIT                106 //     1.
#define ERROR_DISK_CHANGE                   107 //  ,      .
#define ERROR_DRIVE_LOCKED                  108 //      . 
#define ERROR_BROKEN_PIPE                   109 //  .
#define ERROR_OPEN_FAILED                   110 //        .
#define ERROR_BUFFER_OVERFLOW               111 //    .
#define ERROR_DISK_FULL                     112 //      .
#define ERROR_NO_MORE_SEARCH_HANDLES        113 //     .
#define ERROR_INVALID_TARGET_HANDLE         114 //     .
#define ERROR_INVALID_CATEGORY              117 // IOCTL  -    . 
#define ERROR_INVALID_VERIFY_SWITCH         118 // "Verify-on-write"-    . 
#define ERROR_BAD_DRIVER_LEVEL              119 //    .
#define ERROR_CALL_NOT_IMPLEMENTED          120 //       .
#define ERROR_SEM_TIMEOUT                   121 //  - . 
#define ERROR_INSUFFICIENT_BUFFER           122 //  ,    ,  .
#define ERROR_INVALID_NAME                  123 //   ,     .
#define ERROR_INVALID_LEVEL                 124 //     .
#define ERROR_NO_VOLUME_LABEL               125 //     .
#define ERROR_MOD_NOT_FOUND                 126 //    .
#define ERROR_PROC_NOT_FOUND                127 //    .
#define ERROR_WAIT_NO_CHILDREN              128 //       .
#define ERROR_CHILD_NOT_COMPLETE            129 //        Win32.
#define ERROR_DIRECT_ACCESS_HANDLE          130 //          ,   / .
#define ERROR_NEGATIVE_SEEK                 131 //        .
#define ERROR_SEEK_ON_DEVICE                132 //            .
#define ERROR_IS_JOIN_TARGET                133 // JOIN  SUBST       ,    .
#define ERROR_IS_JOINED                     134 //     SUBST   ,   .
#define ERROR_IS_SUBSTED                    135 //     SUBST   ,    . 
#define ERROR_NOT_JOINED                    136 //     ,   .
#define ERROR_NOT_SUBSTED                   137 //     ,   .
#define ERROR_JOIN_TO_JOIN                  138 //         .
#define ERROR_SUBST_TO_SUBST                139 //         .
#define ERROR_JOIN_TO_SUBST                 140 //         .
#define ERROR_SUBST_TO_JOIN                 141 //   SUBST      .
#define ERROR_BUSY_DRIVE                    142 //       SUBST   .
#define ERROR_SAME_DRIVE                    143 //              .
#define ERROR_DIR_NOT_ROOT                  144 //     .
#define ERROR_DIR_NOT_EMPTY                 145 //   .
#define ERROR_IS_SUBST_PATH                 146 // ,       .
#define ERROR_IS_JOIN_PATH                  147 //      .
#define ERROR_PATH_BUSY                     148 //         .
#define ERROR_IS_SUBST_TARGET               149 //     ,         .
#define ERROR_SYSTEM_TRACE                  150 //         CONFIG.SYS,   .
#define ERROR_INVALID_EVENT_COUNT           151 //     DosMuxSemWait   .
#define ERROR_TOO_MANY_MUXWAITERS           152 // DosMuxSemWait  ,     .
#define ERROR_INVALID_LIST_FORMAT           153 //  DosMuxSemWait   .
#define ERROR_LABEL_TOO_LONG                154 //       Label    .
#define ERROR_TOO_MANY_TCBS                 155 //      .
#define ERROR_SIGNAL_REFUSED                156 //    .
#define ERROR_DISCARDED                     157 //        .
#define ERROR_NOT_LOCKED                    158 //   .
#define ERROR_BAD_THREADID_ADDR             159 //      .
#define ERROR_BAD_ARGUMENTS                 160 //       .
#define ERROR_BAD_PATHNAME                  161 //   .
#define ERROR_SIGNAL_PENDING                162 //   .
#define ERROR_MAX_THRDS_REACHED             164 //        .
#define ERROR_LOCK_FAILED                   167 //       .
#define ERROR_BUSY                          170 //     .
#define ERROR_CANCEL_VIOLATION              173 //          .
#define ERROR_ATOMIC_LOCKS_NOT_SUPPORTED    174 //         .
#define ERROR_INVALID_SEGMENT_NUMBER        180 //       .
#define ERROR_INVALID_ORDINAL               182 //     % 1.
#define ERROR_ALREADY_EXISTS                183 //    ,    .
#define ERROR_INVALID_FLAG_NUMBER           186 //  .
#define ERROR_SEM_NOT_FOUND                 187 //       .
#define ERROR_INVALID_STARTING_CODESEG      188 //     % 1.
#define ERROR_INVALID_STACKSEG              189 //     % 1.
#define ERROR_INVALID_MODULETYPE            190 //     % 1.
#define ERROR_INVALID_EXE_SIGNATURE         191 //   % 1   Win32.
#define ERROR_EXE_MARKED_INVALID            192 //     % 1.
#define ERROR_BAD_EXE_FORMAT                193 //    Win32.
#define ERROR_ITERATED_DATA_EXCEEDS_64k     194 //     % 1.
#define ERROR_INVALID_MINALLOCSIZE          195 //     % 1.
#define ERROR_DYNLINK_FROM_INVALID_RING     196 //       .
#define ERROR_IOPL_NOT_ENABLED              197 //           .
#define ERROR_INVALID_SEGDPL                198 //     % 1.
#define ERROR_AUTODATASEG_EXCEEDS_64k       199 //       .
#define ERROR_RING2SEG_MUST_BE_MOVABLE      200 //         64K.
#define ERROR_RELOC_CHAIN_XEEDS_SEGLIM      201 //     % 1.
#define ERROR_INFLOOP_IN_RELOC_CHAIN        202 //     % 1.
#define ERROR_ENVVAR_NOT_FOUND              203 //       ,   .
#define ERROR_NO_SIGNAL_SENT                205 //        .
#define ERROR_FILENAME_EXCED_RANGE          206 //        .
#define ERROR_RING2_STACK_IN_USE            207 // 2   .
#define ERROR_META_EXPANSION_TOO_LONG       208 //    "*"  "?",       .
#define ERROR_INVALID_SIGNAL_NUMBER         209 //     .
#define ERROR_THREAD_1_INACTIVE             210 //    .
#define ERROR_LOCKED                        212 //       .
#define ERROR_TOO_MANY_MODULES              214 //             .
#define ERROR_NESTING_NOT_ALLOWED           215 //    LoadModule.
#define ERROR_EXE_MACHINE_TYPE_MISMATCH     216 //  1    ,    .    ,  ,   x86 (32-)  x64 (64- )  ,       . 
#define ERROR_EXE_CAN_MOD_SIGNED_BINARY     217 //    1,    .
#define ERROR_EXE_CAN_MOD_STRONG_SIG_BIN    218 //    ,    .
#define ERROR_FILE_CHECKED_OUT              220 //         .
#define ERROR_CHECKOUT_REQUIRED             221 //        .
#define ERROR_BAD_FILE_TYPE                 222 //       .
#define ERROR_FILE_TOO_LARGE                223 //     ,     .
#define ERROR_FORMS_AUTH_REQUIRED           224 // Access Denied.      ,     -    ,   -,     .
#define ERROR_VIRUS_INFECTED                225 //     ,     .
#define ERROR_VIRUS_DELETED                 226 //         . -   ,       .
#define ERROR_PIPE_LOCAL                    229 //    .
#define ERROR_BAD_PIPE                      230 //   .
#define ERROR_PIPE_BUSY                     231 //    .
#define ERROR_NO_DATA                       232 //  .
#define ERROR_PIPE_NOT_CONNECTED            233 //      .
#define ERROR_MORE_DATA                     234 // More data is available.  .
#define ERROR_VC_DISCONNECTED               240 //  .
#define ERROR_INVALID_EA_NAME               254 // The specified extended attribute name was invalid.Extended      .
#define ERROR_EA_LIST_INCONSISTENT          255 // The extended attributes are inconsistent.     .
#define WAIT_TIMEOUT                        258 //    .
#define ERROR_NO_MORE_ITEMS                 259 //     .
#define ERROR_CANNOT_COPY                   266 //      .
#define ERROR_DIRECTORY                     267 //   .
#define ERROR_EAS_DIDNT_FIT                 275 //      .
#define ERROR_EA_FILE_CORRUPT               276 //       .
#define ERROR_EA_TABLE_FULL                 277 //     .
#define ERROR_INVALID_EA_HANDLE             278 //      .
#define ERROR_EAS_NOT_SUPPORTED             282 //       .
#define ERROR_NOT_OWNER                     288 //     .
#define ERROR_TOO_MANY_POSTS                298 // Too many posts were made to a semaphore.       .
#define ERROR_PARTIAL_COPY                  299 //    ReadProcessMemory  WriteProcessMemory  .
#define ERROR_OPLOCK_NOT_GRANTED            300 //    .
#define ERROR_INVALID_OPLOCK_PROTOCOL       301 //       .
#define ERROR_DISK_TOO_FRAGMENTED           302 //   ,    .
#define ERROR_DELETE_PENDING                303 //     ,      .
#define ERROR_MR_MID_NOT_FOUND              317 //         0x% 1    2.
#define ERROR_SCOPE_NOT_FOUND               318 //     .
#define ERROR_FAIL_NOACTION_REBOOT          350 // No action was taken as a system reboot is required.    ,    .
#define ERROR_FAIL_SHUTDOWN                 351 //    .
#define ERROR_FAIL_RESTART                  352 //   .
#define ERROR_MAX_SESSIONS_REACHED          353 //    .
#define ERROR_THRD_MODE_ALRDY_BACKGRND      400 //      .
#define ERROR_THRD_MODE_NOT_BACKGRND        401 //      .
#define ERROR_PROCSS_MODE_ALRDY_BACKGRND    402 //       .
#define ERROR_PROCSS_MODE_NOT_BACKGRND      403 //      .
#define ERROR_INVALID_ADDRESS               487 //     .
//====    "SetFilePointer()". =========================================================================================================================================================================================
#define FILE_BEGIN                            0 //   .
#define FILE_CURRENT                          1 //   .
#define FILE_END                              2 //   .
//========================================================================================================================================================================================================================================
#import "kernel32.dll"
 //   p    .    p    HFILE_ERROR = -1.
 int    _hread(int    hFile,    //  .
    /*VARIANT*/string lpBuffer, // p/ p.
               int    lBytes);  //   .     -  .
 //    p   .    p    HFILE_ERROR = -1.
 int    _hwrite(int    hFile,    //  .
     /*VARIANT*/string lpBuffer, // p/ p.
                int    lBytes);  //   .     -  .
 // p  . p: 0.    p    HFILE_ERROR = -1.
 int    _lclose(int hFile); //  .
 //   .   p:  .    p    HFILE_ERROR = -1.
 int    _lcreat(string lpPathName,  // p, p    .
                int    iAttribute); // 0 -   ; 1 -  ; 2 - ; 3 - .
 //    p . p   .    p    HFILE_ERROR = -1.
 int    _llseek(int hFile,    //  .
                int lOffset,  //  ,  p p .
                int iOrigin); //     p p: 0 - p  ; 1 -   ; 2 -    .
 // p  . p  .    p    HFILE_ERROR = -1.
 int    _lopen(string lpPathName,  // p, p    .
               int    iReadWrite); //  .
 //   p    . p:   ; 0 -   .    p    HFILE_ERROR = -1.
 int    _lread(int    hFile,    //  .
    /*VARIANT*/string lpBuffer, // p/ p.
               int    wBytes);  //   .     -  .
 //    p   . p   .    p    HFILE_ERROR = -1.
 int    _lwrite(int    hFile,    //  .
     /*VARIANT*/string lpBuffer, // p/ p.
                int    wBytes);  //   .     -  .
 // 
 int    AddAtomA(uchar &lpString[]);
 int    AddAtomW(string lpString);
 int    AllocConsole();
 int    BackupRead(int hFile, int lpBuffer /*char*/, int nNumberOfBytesToRead, int lpNumberOfBytesRead, int bAbort, int bProcessSecurity, int lpContext /*VARIANT*/);
 int    BackupSeek(int hFile, int dwLowBytesToSeek, int dwHighBytesToSeek, int lpdwLowByteSeeked, int lpdwHighByteSeeked, int lpContext);
 int    BackupWrite(int hFile, int lpBuffer /*char*/, int nNumberOfBytesToWrite, int lpNumberOfBytesWritten, int bAbort, int bProcessSecurity, int lpContext);
 int    Beep(int dwFreq, int dwDuration);
 int    BeginUpdateResourceA(string pFileName, int bDeleteExistingResources);
 int    BuildCommDCBA(uchar &lpDef[], int lpDCB /*DCB*/);
 int    BuildCommDCBW(string lpDef, int lpDCB /*DCB*/);
 int    BuildCommDCBAndTimeoutsA(uchar &lpDef[], int lpDCB /*DCB*/, int lpCommTimeouts /*COMMTIMEOUTS*/);
 int    BuildCommDCBAndTimeoutsW(string lpDef, int lpDCB /*DCB*/, int lpCommTimeouts /*COMMTIMEOUTS*/);
 int    ClearCommBreak(int nCid);
 int    ClearCommError(int hFile, int lpErrors, int lpStat /*COMSTAT*/);
 //        .     TRUE,  FALSE.
 int    CloseHandle(int hObject); //   ,      CreateFileMapping.
 int    CommConfigDialogA(uchar &lpszName[], int hWnd, int lpCC /*COMMCONFIG*/);
 int    CommConfigDialogW(string lpszName, int hWnd, int lpCC /*COMMCONFIG*/);
 int    CompareFileTime(int lpFileTime1 /*FILETIME*/, int lpFileTime2 /*FILETIME*/);
 int    CompareStringA(int Locale, int dwCmpFlags, uchar &lpString1[], int cchCount1, uchar &lpString2[], int cchCount2);
 int    CompareStringW(int Locale, int dwCmpFlags, string lpString1, int cchCount1, string lpString2, int cchCount2);
 int    ConnectNamedPipe(int hNamedPipe, int lpOverlapped /*OVERLAPPED*/);
 int    ContinueDebugEvent(int dwProcessId, int dwThreadId, int dwContinueStatus);
 int    ConvertDefaultLocale(int Locale);
 int    CopyFileA(uchar &lpExistingFileName[], uchar &lpNewFileName[], int bFailIfExists);
 int    CopyFileW(string lpExistingFileName, string lpNewFileName, int bFailIfExists);
 int    CreateDirectoryA(uchar &lpPathName[], int lpSecurityAttributes /*SECURITY_ATTRIBUTES*/);
 int    CreateDirectoryW(string lpPathName, int lpSecurityAttributes /*SECURITY_ATTRIBUTES*/);
 int    CreateDirectoryExA(uchar &lpTemplateDirectory[], uchar &lpNewDirectory[], int lpSecurityAttributes /*SECURITY_ATTRIBUTES*/);
 int    CreateDirectoryExW(string lpTemplateDirectory, string lpNewDirectory, int lpSecurityAttributes /*SECURITY_ATTRIBUTES*/);
 int    CreateEventA(int lpEventAttributes /*SECURITY_ATTRIBUTES*/, int bManualReset, int bInitialState, uchar &lpName[]);
 int    CreateEventW(int lpEventAttributes /*SECURITY_ATTRIBUTES*/, int bManualReset, int bInitialState, string lpName);
 //     ,  , ,  (CONIN$  CONOUT$),    ,  ,     .
 //   ,        .    - HFILE_ERROR(-1).
 //    ,   -    .       ,   dwCreationDisposition   CREATE_ALWAYS  OPEN_ALWAYS,
 //   GetLastError   ERROR_ALREADY_EXISTS(  ,    ).       ,  GetLastError  .
 //     ,   - INVALID_HANDLE_VALUE.      ,  GetLastError.
 int    CreateFileA(uchar &lpFileName[], int dwDesiredAccess, int dwShareMode, int lpSecurityAttributes, int dwCreationDisposition, int dwFlagsAndAttributes, int hTemplateFile);
 int    CreateFileW(string lpFileName,            //      .
                    int    dwDesiredAccess,       //    (,     ).      ,        ,
                                                  //      ,      .     ,      ,
                                                  //    .     ,       ,    .     ,
                                                  //       -   ,   ,       .
                                                  //       ,      ,        .
                                                  // ---- Access right. -----------------------+-----------------------------------------------------------------------------------------------------------------------------------------
                                                  // GENERIC_EXECUTE	FILE_READ_ATTRIBUTES      | ()   :
                                                  //                   STANDARD_RIGHTS_EXECUTE | CreateFileA(PathName, GENERIC_WRITE, FILE_SHARE_READ|FILE_SHARE_WRITE, 0, CREATE_ALWAYS, 0, 0);
                                                  //                   SYNCHRONIZE             +-----------------------------------------------------------------------------------------------------------------------------------------
                                                  // GENERIC_READ	   FILE_READ_ATTRIBUTES      |      :
                                                  //                   FILE_READ_DATA          | CreateFileA(PathName, GENERIC_WRITE|GENERIC_READ, FILE_SHARE_READ|FILE_SHARE_WRITE, 0, OPEN_EXISTING, 0, 0);
                                                  //                   FILE_READ_EA            |
                                                  //                   STANDARD_RIGHTS_READ    |
                                                  //                   SYNCHRONIZE             +-----------------------------------------------------------------------------------------------------------------------------------------
                                                  // GENERIC_WRITE     FILE_APPEND_DATA        |    :
                                                  //                   FILE_WRITE_ATTRIBUTES   | CreateFileA(PathName, GENERIC_READ, FILE_SHARE_READ|FILE_SHARE_WRITE, 0, OPEN_EXISTING, 0, 0);
                                                  //                   FILE_WRITE_DATA         | 
                                                  //                   FILE_WRITE_EA           +-----------------------------------------------------------------------------------------------------------------------------------------
                                                  //                   STANDARD_RIGHTS_WRITE
                                                  //                   SYNCHRONIZE
                                                  // ---- Access right. -----------------------------------------------------------------------------------------------------------------------------------------------------------------
                                                  // FILE_ADD_FILE             0x0002  ,     .
                                                  // FILE_ADD_SUBDIRECTORY     0x0004  ,   subdirectory.
                                                  // FILE_ALL_ACCESS                       .
                                                  // FILE_APPEND_DATA          0x0004   ,     .(  ,    
                                                  //                                         FILE_WRITE_DATA.)   ,  
                                                  //                                  subdirectory(FILE_ADD_SUBDIRECTORY).
                                                  // FILE_CREATE_PIPE_INSTANCE 0x0004   ,   .
                                                  // FILE_DELETE_CHILD         0x0040  ,      ,   ,     .
                                                  // FILE_EXECUTE              0x0020    ,   .        ,
                                                  //                                    ,     .
                                                  // FILE_LIST_DIRECTORY       0x0001  ,    .
                                                  // FILE_READ_ATTRIBUTES      0x0080    .
                                                  // FILE_READ_DATA            0x0001   ,     .   ,  
                                                  //                                    .
                                                  // FILE_READ_EA              0x0008     .
                                                  // FILE_TRAVERSE             0x0020  ,   .  ,    BYPASS_TRAVERSE_CHECKING,
                                                  //                                      FILE_TRAVERSE.        .
                                                  // FILE_WRITE_ATTRIBUTES     0x0100    .
                                                  // FILE_WRITE_DATA           0x0002   ,     .   ,     (FILE_ADD_FILE).
                                                  // FILE_WRITE_EA             0x0010     .
                                                  // STANDARD_RIGHTS_READ              READ_CONTROL,  -          .
                                                  //                                       SACL.
                                                  // STANDARD_RIGHTS_WRITE            ,  STANDARD_RIGHTS_READ.
                                                  // SYNCHRONIZE                              .   ,     /,
                                                  //                                                 .
                    int    dwShareMode,           //   (, ,    ).       ,       ,
                                                  //      ,      .  ,       (ERROR_SHARING_VIOLATION).
                                                  //     ,  CreateFile  ,     ,         ,    .
                                                  //        ,   ,    ,        ,
                                                  //    ,    ,   .          ,      .
                                                  // FILE_SHARE_NO      0x00000000      .
                                                  // FILE_SHARE_DELETE  0x00000004            .
                                                  //                                   ,             .
                                                  //                                     ,        ,   .
                                                  //                                  ,       .
                                                  // FILE_SHARE_READ    0x00000001            .
                                                  //                                   ,             .
                                                  //                                     ,        ,   .
                                                  // FILE_SHARE_WRITE   0x00000002            .
                                                  //                                   ,             .
                                                  //                                     ,           ,
                                                  //                                    ,   .
                    int    lpSecurityAttributes,  // SD( ).    SECURITY_ATTRIBUTES,          .
                                                  //  lpSecurityAttributes   (NULL),     .
                                                  // Windows NT/2000/XP:   lpSecurityDescriptor      .  lpSecurityAttributes   (NULL),
                                                  //       .   (ACL)           
                                                  //    .  !  ,    ,          ,    
                                                  //  .(  ,   GetVolumeInformation   FS_PERSISTENT_ACLS.) CreateFile   lpSecurityDescriptor 
                                                  //   ,      .
                    int    dwCreationDisposition, //    ,       ,   .      .   .
                                                  //        :
                                                  // CREATE_ALWAYS     2    , .      - writable,   ,   ,
                                                  //                            ERROR_ALREADY_EXISTS(183).       -  ,
                                                  //                        ,   ,       .
                                                  // CREATE_NEW        1    ,   .   ,         
                                                  //                      ERROR_FILE_EXISTS(80).           writable,    .
                                                  // OPEN_ALWAYS       4   , .   ,         ERROR_ALREADY_EXISTS(183).
                                                  //                                writable,        - .
                                                  // OPEN_EXISTING     3     ,    .      ,    
                                                  //                           ERROR_FILE_NOT_FOUND(2).
                                                  // TRUNCATE_EXISTING 5	       -  ,    .    , 
                                                  //                           ERROR_FILE_NOT_FOUND(2).        GENERIC_WRITE 
                                                  //                         dwDesiredAccess.
                    int    dwFlagsAndAttributes,  //    .      ,      ,     ,   CreateFile.
                                                  //  CreateFile   ,        ,      .
                                                  //          (,           FILE_ATTRIBUTE_NORMAL):
                                                  // ------------ . -------------------------------------------------------------------------------------------------------------------------------
                                                  // FILE_ATTRIBUTE_ARCHIVE      32  0x20           .    ,       .
                                                  // FILE_ATTRIBUTE_ENCRYPTED 16384  0x4000         .  ,  ,      .
                                                  //                                              ,  ,          .
                                                  //                                                   FILE_ATTRIBUTE_SYSTEM  .
                                                  // FILE_ATTRIBUTE_HIDDEN        2  0x2          .       .
                                                  // FILE_ATTRIBUTE_NORMAL      128  0x80             .    ,    .
                                                  // FILE_ATTRIBUTE_OFFLINE    4096  0x1000          .   ,     
                                                  //                                              offline .     ,   
                                                  //                                              .       .
                                                  // FILE_ATTRIBUTE_READONLY      1  0x1           .    ,        .
                                                  // FILE_ATTRIBUTE_SYSTEM        4  0x4                .
                                                  // FILE_ATTRIBUTE_TEMPORARY   256  0x100           .
                                                  // -----------------------------------------------------------------------------------------------------------------------------------------------------
                                                  //            :
                                                  // ------------- . ---------------------------------------------------------------------------------------------------------------------------------
                                                  // FILE_FLAG_BACKUP_SEMANTICS      0x02000000          .  ,  
                                                  //                                                     SE_BACKUP_NAME  
                                                  //                                             SE_RESTORE_NAME.  ,     .
                                                  //                                                 ,     .      
                                                  //                                                 .  ,   .
                                                  // FILE_FLAG_DELETE_ON_CLOSE       0x04000000       ,    
                                                  //                                                   .      ,  
                                                  //                                                      FILE_SHARE_DELETE.  
                                                  //                                                 ,    FILE_SHARE_DELETE  .
                                                  // FILE_FLAG_NO_BUFFERING          0x20000000       ,      .
                                                  //                                                        .   
                                                  //                                                  CreateFile,   FILE_FLAG_NO_BUFFERING,
                                                  //                                                 .
                                                  // FILE_FLAG_OPEN_NO_RECALL        0x00100000    ,        .
                                                  //                                                   .       .
                                                  // FILE_FLAG_OPEN_REPARSE_POINT    0x00200000   reparse    ; CreateFile   reparse .
                                                  //                                               ,   ,    ,   , .
                                                  //                                                    CREATE_ALWAYS.   -  reparse ,    .
                                                  // FILE_FLAG_OVERLAPPED            0x40000000          /.    /
                                                  //                                                ,    OVERLAPPED      .
                                                  //                                                ,          .
                                                  //                                                 ,   /  ,        
                                                  //                                               OVERLAPPED .
                                                  // FILE_FLAG_POSIX_SEMANTICS       0x0100000       POSIX.       ,
                                                  //                                                , ,   ,     .
                                                  //                                                  ,        
                                                  //                                              ,    -DOS  16- Windows.
                                                  // FILE_FLAG_RANDOM_ACCESS         0x10000000     .      ,  
                                                  //                                              .            /  FILE_FLAG_NO_BUFFERING.
                                                  // FILE_FLAG_SEQUENTIAL_SCAN       0x08000000       ,  .     
                                                  //                                             ,    .       -
                                                  //                                            ( , ( ) ),  .       
                                                  //                                                 /  FILE_FLAG_NO_BUFFERING.
                                                  // FILE_FLAG_WRITE_THROUGH         0x80000000         ,     .
                                                  // -----------------------------------------------------------------------------------------------------------------------------------------------------
                    int    hTemplateFile);        //       GENERIC_READ.          ,  .
                                                  //     NULL.    , CreateFile   .     ,
                                                  //          .
 //     C   .   -       ()    ,  THandle.
 //              .    -       ,     0.
 int    CreateFileMappingA(int hFile, int lpFileMappigAttributes, int flProtect, int dwMaximumSizeHigh, int dwMaximumSizeLow, uchar &lpName[]);
 int    CreateFileMappingW(int hFile,                  //   -       $FFFFFFFF  
                                                       //  Windows.pas  MAXDWORD         -.
   /*SECURITY_ATTRIBUTES*/ int lpFileMappigAttributes, //     TSecurityAttributes,        -    NULL.
                           int flProtect,              //     ,         .
                                                       // PAGE_READWRITE -         (    fmOpenReadWrite);
                                                       // PAGE_READONLY  -    (        fmOpenRead);
                                                       // PAGE_WRITECOPY -      ,         
                                                       //                 (    ,               );
                           int dwMaximumSizeHigh,      //   64-        ( 4 Gbt)-     :) -     0.
                           int dwMaximumSizeLow,       //   64-         -   dwMaximumSizeHigh  0,      
                                                       //        .     ,   ""  Intel  4 KBt, ..    1   
                                                       // "   " :)  4 KBt,   4001,           8Kbt   ..
                                                       //     0,      .
                           string lpName);             //    .
 int    CreateIoCompletionPort(int FileHandle, int ExistingCompletionPort, int CompletionKey, int NumberOfConcurrentThreads);
 int    CreateMailslotA(uchar &lpName[], int nMaxMessageSize, int lReadTimeout, int lpSecurityAttributes /*SECURITY_ATTRIBUTES*/);
 int    CreateMailslotW(string lpName, int nMaxMessageSize, int lReadTimeout, int lpSecurityAttributes /*SECURITY_ATTRIBUTES*/);
 int    CreateMutexA(int lpMutexAttributes /*SECURITY_ATTRIBUTES*/, int bInitialOwner, uchar &lpName[]);
 int    CreateMutexW(int lpMutexAttributes /*SECURITY_ATTRIBUTES*/, int bInitialOwner, string lpName);
 int    CreateNamedPipeA(uchar &lpName[], int dwOpenMode, int dwPipeMode, int nMaxInstances, int nOutBufferSize, int nInBufferSize, int nDefaultTimeOut, int lpSecurityAttributes /*SECURITY_ATTRIBUTES*/);
 int    CreateNamedPipeW(string lpName, int dwOpenMode, int dwPipeMode, int nMaxInstances, int nOutBufferSize, int nInBufferSize, int nDefaultTimeOut, int lpSecurityAttributes /*SECURITY_ATTRIBUTES*/);
 int    CreatePipe(int phReadPipe, int phWritePipe, int lpPipeAttributes /*SECURITY_ATTRIBUTES*/, int nSize);
 //      .        .
 //    ,     .    ,    .
 int    CreateProcessA(uchar &lpApplicationName[], uchar &lpCommandLine[], int lpProcessAttributes, int lpThreadAttributes, int bInheritHandles, int dwCreationFlags, int lpEnvironment, string lpCurrentDriectory, int &lpStartupInfo[], int &lpProcessInformation[]);
 int    CreateProcessW(string lpApplicationName,       //    .
                       string lpCommandLine,           //    .
/*SECURITY_ATTRIBUTES*/int    lpProcessAttributes,     //    SECURITY_ATTRIBUTES,              .
                                                       //  lpProcessAttributes NULL,     . 
/*SECURITY_ATTRIBUTES*/int    lpThreadAttributes,      //    SECURITY_ATTRIBUTES,              .
                                                       //  lpThreadAttributes NULL,     . 
                       int    bInheritHandles,         //   TRUE ,  inheritable       .    FALSE,   .
                                                       // ,             .
                       int    dwCreationFlags,         // ,       .   ,    .
                                                       // CREATE_BREAKAWAY_FROM_JOB                .
                                                       // CREATE_DEFAULT_ERROR_MODE                . ,      .
                                                       // CREATE_NEW_CONSOLE                    ,    ( ).
                                                       // CREATE_NEW_PROCESS_GROUP                 .     ,  -    .
                                                       // CREATE_NO_WINDOW                     ,     .      .
                                                       // CREATE_PROTECTED_PROCESS                .          .
                                                       // CREATE_PRESERVE_CODE_AUTHZ_LEVEL    ,    ,    ,       .
                                                       // CREATE_SEPARATE_WOW_VDM             -      16-    Windows.  ,       Virtual DOS(VDM).
                                                       // CREATE_SHARED_WOW_VDM              -      16-    Windows.  DefaultSeparateVDM   Windows WIN.INI  ,    .
                                                       // CREATE_SUSPENDED                                ResumeThread   .
                                                       // CREATE_UNICODE_ENVIRONMENT           ,   ,  lpEnvironment   .   ,     ANSI.
                                                       // DEBUG_ONLY_THIS_PROCESS                 .       ,   WaitForDebugEvent.
                                                       // DEBUG_PROCESS                                  .
                                                       // DETACHED_PROCESS                    ,       (  ).
                                                       // EXTENDED_STARTUPINFO_PRESENT          ;  lpStartupInfo   STARTUPINFOEX.
                                                       // INHERIT_PARENT_AFFINITY               .
/*VARIANT*/            int    lpEnvironment,           //      .    NULL,      .
                       string lpCurrentDriectory,      //       .      UNC.    ,      
                                                       //       .(     ,      
                                                       //      .)
/*STARTUPINFO*/        int   &lpStartupInfo[],         //   STARTUPINFO   STARTUPINFOEX.  ,    ,   STARTUPINFOEX 
                                                       //  EXTENDED_STARTUPINFO_PRESENT   dwCreationFlags.
/*PROCESS_INFORMATION*/int   &lpProcessInformation[]); //    PROCESS_INFORMATION,       . 
                                                       //   PROCESS_INFORMATION    CloseHandle,     .
 int    CreateProcessAsUserA(int hToken, uchar &lpApplicationName[], uchar &lpCommandLine[], int lpProcessAttributes /*SECURITY_ATTRIBUTES*/, int lpThreadAttributes /*SECURITY_ATTRIBUTES*/, int bInheritHandles, int dwCreationFlags, uchar &lpEnvironment[], uchar &lpCurrentDirectory[], int lpStartupInfo /*STARTUPINFO*/, int lpProcessInformation /*PROCESS_INFORMATION*/);
 int    CreateProcessAsUserW(int hToken, string lpApplicationName, string lpCommandLine, int lpProcessAttributes /*SECURITY_ATTRIBUTES*/, int lpThreadAttributes /*SECURITY_ATTRIBUTES*/, int bInheritHandles, int dwCreationFlags, string lpEnvironment, string lpCurrentDirectory, int lpStartupInfo /*STARTUPINFO*/, int lpProcessInformation /*PROCESS_INFORMATION*/);
 int    CreateRemoteThread(int hProcess, int lpThreadAttributes /*SECURITY_ATTRIBUTES*/, int dwStackSize, int lpStartAddress, int lpParameter /*VARIANT*/, int dwCreationFlags, int lpThreadId);
 int    CreateSemaphoreA(int lpSemaphoreAttributes /*SECURITY_ATTRIBUTES*/, int lInitialCount, int lMaximumCount, uchar &lpName[]);
 int    CreateSemaphoreW(int lpSemaphoreAttributes /*SECURITY_ATTRIBUTES*/, int lInitialCount, int lMaximumCount, string lpName);
 int    CreateTapePartition(int hDevice, int dwPartitionMethod, int dwCount, int dwSize);
 int    CreateThread(int lpThreadAttributes /*SECURITY_ATTRIBUTES*/, int dwStackSize, int lpStartAddress, int lpParameter /*VARIANT*/, int dwCreationFlags, int lpThreadId);
 int    DefineDosDeviceA(int dwFlags, uchar &lpDeviceName[], uchar &lpTargetPath[]);
 int    DefineDosDeviceW(int dwFlags, string lpDeviceName, string lpTargetPath);
 int    DeleteAtom(int nAtom);
 void   DeleteCriticalSection(int lpCriticalSection /*CRITICAL_SECTION*/);
 int    DeleteFileA(uchar &lpFileName[]);
 int    DeleteFileW(string lpFileName);
 int    DeviceIoControl(int hDevice, int dwIoControlCode, int lpInBuffer /*VARIANT*/, int nInBufferSize, int lpOutBuffer /*VARIANT*/, int nOutBufferSize, int lpBytesReturned, int lpOverlapped /*OVERLAPPED*/);
 int    DisableThreadLibraryCalls(int hLibModule);
 int    DisconnectNamedPipe(int hNamedPipe);
 int    DosDateTimeToFileTime(int wFatDate, int wFatTime, int lpFileTime /*FILETIME*/);
 int    DuplicateHandle(int hSourceProcessHandle, int hSourceHandle, int hTargetProcessHandle, int lpTargetHandle, int dwDesiredAccess, int bInheritHandle, int dwOptions);
 int    EndUpdateResource(int hUpdate, int fDiscard);
 void   EnterCriticalSection(int lpCriticalSection /*CRITICAL_SECTION*/);
 int    EnumCalendarInfoA(int lpCalInfoEnumProc, int Locale, int Calendar, int CalType);
 int    EnumCalendarInfoW(int lpCalInfoEnumProc, int Locale, int Calendar, int CalType);
 int    EnumDateFormats(int lpDateFmtEnumProc, int Locale, int dwFlags);
 int    EnumResourceLanguagesA(int hModule, uchar &lpType[], uchar &lpName[], int lpEnumFunc, int lParam);
 int    EnumResourceLanguagesW(int hModule, string lpType, string lpName, int lpEnumFunc, int lParam);
 int    EnumResourceNamesA(int hModule, uchar &lpType[], int lpEnumFunc, int lParam);
 int    EnumResourceNamesW(int hModule, string lpType, int lpEnumFunc, int lParam);
 int    EnumResourceTypesA(int hModule, int lpEnumFunc, int lParam);
 int    EnumResourceTypesW(int hModule, int lpEnumFunc, int lParam);
 int    EnumSystemCodePages(int lpCodePageEnumProc, int dwFlags);
 int    EnumSystemLocales(int lpLocaleEnumProc, int dwFlags);
 int    EnumTimeFormats(int lpTimeFmtEnumProc, int Locale, int dwFlags);
 int    EraseTape(int hDevice, int dwEraseType, int bimmediate);
 int    EscapeCommFunction(int nCid, int nFunc);
 void   ExitProcess(int uExitCode);
 void   ExitThread(int dwExitCode);
 int    ExpandEnvironmentStringsA(uchar &lpSrc[], uchar &lpDst[], int nSize);
 int    ExpandEnvironmentStringsW(string lpSrc, string lpDst, int nSize);
 void   FatalAppExitA(int uAction, uchar &lpMessageText[]);
 void   FatalAppExitW(int uAction, string lpMessageText);
 void   FatalExit(int code);
 int    FileTimeToDosDateTime(int lpFileTime /*FILETIME*/, int lpFatDate, int lpFatTime);
 int    FileTimeToLocalFileTime(int lpFileTime /*FILETIME*/, int lpLocalFileTime /*FILETIME*/);
 int    FileTimeToSystemTime(int lpFileTime /*FILETIME*/, int lpSystemTime /*SYSTEMTIME*/);
 int    FillConsoleOutputAttribute(int hConsoleOutput, int wAttribute, int nLength, int dwWriteCoord /*COORD*/, int lpNumberOfAttrsWritten);
 int    FillConsoleOutputCharacter(int hConsoleOutput, int cCharacter /*Byte*/, int nLength, int dwWriteCoord /*COORD*/, int lpNumberOfCharsWritten);
 int    FindAtomA(uchar &lpString[]);
 int    FindAtomW(string lpString);
 //  FindClose    ,   FindFirstFile  FindFirstFileEx  FindFirstStreamW.
 //    ,   -  .
 //    ,    - . 
 int    FindClose(int hFindFile); //     "FindFirstFileA()".
 int    FindCloseChangeNotification(int hChangeHandle);
 int    FindFirstChangeNotificationA(uchar &lpPathName[], int bWatchSubtree, int dwNotifyFilter);
 int    FindFirstChangeNotificationW(string lpPathName, int bWatchSubtree, int dwNotifyFilter);
 //  FindFirstFile           ,     .        .
 //    ,   -  ,      FindNextFile  FindClose.
 //    ,   - INVALID_HANDLE_VALUE.
 int    FindFirstFileA(uchar &lpFileName[], int &lpFindFileData[]);
 int    FindFirstFileW(string lpFileName,        //   .
                       int   &lpFindFileData[]); //    WIN32_FIND_DATA,         .
 //  "FindFirstStream()"        .    ,   -  ,  
 //      FindNextStreamW.    ,   - INVALID_HANDLE_VALUE.
 int    FindFirstStreamA(uchar &lpFileName[], /*STREAM_INFO_LEVELS*/ int InfoLevel, int &lpFindStreamData[], int dwFlags);
 int    FindFirstStreamW(string lpFileName, /*STREAM_INFO_LEVELS*/ int InfoLevel, int &lpFindStreamData[], int dwFlags);
 int    FindNextChangeNotification(int hChangeHandle);
 //  FindNextStream   ,     FindFirstStream.
 int    FindNextStreamA(int hFindStream, /*LPVOID*/ int &lpFindStreamData[]);
 int    FindNextStreamW(int hFindStream, /*LPVOID*/ int &lpFindStreamData[]);
 //  FindNextFile         FindFirstFile  FindFirstFileEx.    ,   -  .
 int    FindNextFileA(int hFindFile, int &lpFindFileData[]);
 int    FindNextFileW(int  hFindFile,         //     "FindFirstFileA()".
                      int &lpFindFileData[]); //    WIN32_FIND_DATA,         .
 int    FindResourceA(int hInstance, uchar &lpName[], uchar &lpType[]);
 int    FindResourceW(int hInstance, string lpName, string lpType);
 int    FindResourceExA(int hModule, uchar &lpType[], uchar &lpName[], int wLanguage);
 int    FindResourceExW(int hModule, string lpType, string lpName, int wLanguage);
 //                .    ,   -  .
 int    FlushFileBuffers(int hFile); //  
 //           .    ,   -  .    ,    - .
 int    FlushViewOfFile(int lpBaseAddress,           //  .
                        int dwNumberOfBytesToFlush); //    .
 int    FormatMessageA(int dwFlags, uchar &lpSource[], int dwMessageId, int dwLanguageId, int &lpBuffer[], int nSize, int Arguments);
 int    FormatMessageW(int dwFlags, string lpSource, int dwMessageId, int dwLanguageId, int &lpBuffer[], int nSize, int Arguments);
 int    FreeConsole();
 int    FreeEnvironmentStringsA(uchar &lpsz[]);
 int    FreeEnvironmentStringsW(string lpsz);
 int    FreeLibrary(int hLibModule);
 void   FreeLibraryAndExitThread(int hLibModule, int dwExitCode);
 int    FreeResource(int hResData);
 int    GenerateConsoleCtrlEvent(int dwCtrlEvent, int dwProcessGroupId);
 int    GetACP();
 int    GetAtomNameA(int nAtom, uchar &lpBuffer[], int nSize);
 int    GetAtomNameW(int nAtom, string lpBuffer, int nSize);
 int    GetBinaryTypeA(uchar &lpApplicationName[], int lpBinaryType);
 int    GetBinaryTypeW(string lpApplicationName, int lpBinaryType);
 string GetCommandLine();
 int    GetCommConfig(int hCommDev, int lpCC /*COMMCONFIG*/, int lpdwSize);
 int    GetCommMask(int hFile, int lpEvtMask);
 int    GetCommModemStatus(int hFile, int lpModemStat);
 int    GetCommProperties(int hFile, int lpCommProp /*COMMPROP*/);
 int    GetCommState(int nCid, int lpDCB /*DCB*/);
 int    GetCommTimeouts(int hFile, int lpCommTimeouts /*COMMTIMEOUTS*/);
 int    GetCompressedFileSizeA(string lpFileName, int lpFileSizeHigh);
 int    GetCompressedFileSizeW(string lpFileName, int lpFileSizeHigh);
 int    GetComputerNameA(uchar &lpBuffer[], int nSize);
 int    GetComputerNameW(string lpBuffer, int nSize);
 int    GetConsoleCP();
 int    GetConsoleCursorInfo(int hConsoleOutput, int lpConsoleCursorInfo /*CONSOLE_CURSOR_INFO*/);
 int    GetConsoleMode(int hConsoleHandle, int lpMode);
 int    GetConsoleOutputCP();
 int    GetConsoleScreenBufferInfo(int hConsoleOutput, int lpConsoleScreenBufferInfo /*CONSOLE_SCREEN_BUFFER_INFO*/);
 int    GetCurrentProcess();
 int    GetDateFormatA(int Locale, int dwFlags, int lpDate /*SYSTEMTIME*/, uchar &lpFormat[], uchar &lpDateStr[], int cchDate);
 int    GetDateFormatW(int Locale, int dwFlags, int lpDate /*SYSTEMTIME*/, string lpFormat, string lpDateStr, int cchDate);
 int    GetDefaultCommConfigA(uchar &lpszName[], int lpCC /*COMMCONFIG*/, int lpdwSize);
 int    GetDefaultCommConfigW(string lpszName, int lpCC /*COMMCONFIG*/, int lpdwSize);
 int    GetDiskFreeSpaceA(uchar &lpRootPathName[], int lpSectorsPerCluster, int lpBytesPerSector, int lpNumberOfFreeClusters, int lpTtoalNumberOfClusters);
 int    GetDiskFreeSpaceW(string lpRootPathName, int lpSectorsPerCluster, int lpBytesPerSector, int lpNumberOfFreeClusters, int lpTtoalNumberOfClusters);
 int    GetDriveTypeA(uchar &nDrive[]);
 int    GetDriveTypeW(string nDrive);
 string GetEnvironmentStringsA();
 string GetEnvironmentStringsW();
 int    GetEnvironmentVariableA(uchar &lpName[], string lpBuffer, int nSize);
 int    GetEnvironmentVariableW(string lpName, string lpBuffer, int nSize);
 int    GetExitCodeProcess(int hProcess, int lpExitCode);
 int    GetExitCodeThread(int hThread, int lpExitCode);
 int    GetFileAttributesA(uchar &lpFileName[]);
 int    GetFileAttributesW(string lpFileName);
 int    GetFileInformationByHandle(int hFile, int lpFileInformation /*BY_HANDLE_FILE_INFORMATION*/);
 int    GetFileSize(int hFile, int lpFileSizeHigh);
 int    GetFileTime(int hFile, int lpCreationTime /*FILETIME*/, int lpLastAccessTime /*FILETIME*/, int lpLastWriteTime /*FILETIME*/);
 int    GetFileType(int hFile);
 int    GetFullPathNameA(uchar &lpFileName[], int nBufferLength, uchar &lpBuffer[], uchar &lpFilePart[]);
 int    GetFullPathNameW(string lpFileName, int nBufferLength, string lpBuffer, string lpFilePart);
 int    GetHandleInformation(int hObject, int lpdwFlags);
 int/*COORD*/ GetLargestConsoleWindowSize(int hConsoleOutput);
// int    GetLastError();
 int    GetLocaleInfoA(int Locale, int LCType, uchar &lpLCData[], int cchData);
 int    GetLocaleInfoW(int Locale, int LCType, string lpLCData, int cchData);
 void   GetLocalTime(/*SYSTEMTIME*/ int &TimeArray[]);
        // int Year     = TimeArray[0] & 0x0000FFFF;
        // int Month    = TimeArray[0] >> 16;
        // int Day      = TimeArray[1] >> 16;
        // int Hour     = TimeArray[2] & 0x0000FFFF;
        // int Min      = TimeArray[2] >> 16;
        // int Sec      = TimeArray[3] & 0x0000FFFF;
        // int MilliSec = TimeArray[3] >> 16;
 int    GetLogicalDrives();
 int    GetLogicalDriveStringsA(int nBufferLength, uchar &lpBuffer[]);
 int    GetLogicalDriveStringsW(int nBufferLength, string lpBuffer);
 int    GetMailslotInfo(int hMailslot, int lpMaxMessageSize, int lpNextSize, int lpMessageCount, int lpReadTimeout);
 int    GetModuleFileName(int hModule, string lpFileName, int nSize);
 int    GetModuleHandleA(uchar &lpModuleName[]);
 int    GetModuleHandleW(string lpModuleName);
 int    GetOEMCP();
 int    GetOverlappedResult(int hFile, int lpOverlapped /*OVERLAPPED*/, int lpNumberOfBytesTransferred, int bWait);
 int    GetPriorityClass(int hProcess);
 int    GetPrivateProfileIntA(uchar &lpApplicationName[], uchar &lpKeyName[], int nDefault, uchar &lpFileName[]);
 int    GetPrivateProfileIntW(string lpApplicationName, string lpKeyName, int nDefault, string lpFileName);
 int    GetPrivateProfileSectionA(uchar &lpAppName[], uchar &lpReturnedString[], int nSize, uchar &lpFileName[]);
 int    GetPrivateProfileSectionW(string lpAppName, string lpReturnedString, int nSize, string lpFileName);
 //       p  .
 int    GetPrivateProfileStringA(uchar &lpApplicationName[], uchar &lpKeyName[], uchar &lpDefault[], uchar &lpReturnedString[], int nSize, uchar &lpFileName[]);
 int    GetPrivateProfileStringW(string lpApplicationName, //  .   p   FileName.
                                 string lpKeyName,         //  .
                                 string lpDefault,         //   .
                                 string lpReturnedString,  //   .
                                 int    nSize,             //     .
                                 string lpFileName);       //   .
 int    GetProcAddress(int hModule, string lpProcName);
 int    GetProcessAffinityMask(int hProcess, int lpProcessAffinityMask, int SystemAffinityMask);
 int    GetProcessHeap();
 int    GetProcessHeaps(int NumberOfHeaps, int ProcessHeaps);
 int    GetProcessShutdownParameters(int lpdwLevel, int lpdwFlags);
 int    GetProcessTimes(int hProcess, int lpCreationTime /*FILETIME*/, int lpExitTime /*FILETIME*/, int lpKernelTime /*FILETIME*/, int lpUserTime /*FILETIME*/);
 int    GetProcessWorkingSetSize(int hProcess, int lpMinimumWorkingSetSize, int lpMaximumWorkingSetSize);
 int    GetProfileIntA(uchar &lpAppName[], uchar &lpKeyName[], int nDefault);
 int    GetProfileIntW(string lpAppName, string lpKeyName, int nDefault);
 int    GetProfileSectionA(uchar &lpAppName[], uchar &lpReturnedString[], int nSize);
 int    GetProfileSectionW(string lpAppName, string lpReturnedString, int nSize);
 int    GetProfileStringA(uchar &lpAppName[], uchar &lpKeyName[], uchar &lpDefault[], uchar &lpReturnedString[], int nSize);
 int    GetProfileStringW(string lpAppName, string lpKeyName, string lpDefault, string lpReturnedString, int nSize);
 int    GetQueuedCompletionStatus(int CompletionPort, int lpNumberOfBytesTransferred, int lpCompletionKey, int lpOverlapped, int dwMilliseconds);
 int    GetShortPathNameA(uchar &lpszLongPath[], uchar &lpszShortPath[], int cchBuffer);
 int    GetShortPathNameW(uchar &lpszLongPath[], uchar &lpszShortPath[], int cchBuffer);
 void   GetStartupInfoA(int lpStartupInfo /*STARTUPINFO*/);
 void   GetStartupInfoW(int lpStartupInfo /*STARTUPINFO*/);
 int    GetStdHandle(int nStdHandle);
 int    GetStringTypeA(int lcid, int dwInfoType, uchar &lpSrcStr[], int cchSrc, int lpCharType);
 int    GetStringTypeW(int lcid, int dwInfoType, string lpSrcStr, int cchSrc, int lpCharType);
 int    GetStringTypeExA(int Locale, int dwInfoType, uchar &lpSrcStr[], int cchSrc, int lpCharType);
 int    GetStringTypeExW(int Locale, int dwInfoType, string lpSrcStr, int cchSrc, int lpCharType);
 int    GetSystemPowerStatus(int lpSystemPowerStatus /*SYSTEM_POWER_STATUS*/);
 void   GetSystemTime(/*SYSTEMTIME*/ int &TimeArray[]);
        // int Year     = TimeArray[0] & 0x0000FFFF;
        // int Month    = TimeArray[0] >> 16;
        // int Day      = TimeArray[1] >> 16;
        // int Hour     = TimeArray[2] & 0x0000FFFF;
        // int Min      = TimeArray[2] >> 16;
        // int Sec      = TimeArray[3] & 0x0000FFFF;
        // int MilliSec = TimeArray[3] >> 16;
 int    GetSystemTimeAdjustment(int lpTimeAdjustment, int lpTimeIncrement, int lpTimeAdjustmentDisabled);
 int    GetTapeParameters(int hDevice, int dwOperation, int lpdwSize, int lpTapeInformation /*VARIANT*/);
 int    GetTapePosition(int hDevice, int dwPositionType, int lpdwPartition, int lpdwOffsetLow, int lpdwOffsetHigh);
 int    GetTapeStatus(int hDevice);
 int    GetTempFileNameA(uchar &lpszPath[], uchar &lpPrefixString[], int wUnique, uchar &lpTempFileName[]);
 int    GetTempFileNameW(string lpszPath, string lpPrefixString, int wUnique, string lpTempFileName);
 int    GetTempPathA(int nBufferLength, uchar &lpBuffer[]);
 int    GetTempPathW(int nBufferLength, string lpBuffer);
 int    GetThreadContext(int hThread, int lpContext /*CONTEXT*/);
 int    GetThreadLocale();
 int    GetThreadPriority(int hThread);
 int    GetThreadSelectorEntry(int hThread, int dwSelector, int lpSelectorEntry /*LDT_ENTRY*/);
 int    GetThreadTimes(int hThread, int lpCreationTime /*FILETIME*/, int lpExitTime /*FILETIME*/, int lpKernelTime /*FILETIME*/, int lpUserTime /*FILETIME*/);
// int    GetTickCount();
 int    GetTimeFormatA(int Locale, int dwFlags, int lpTime /*SYSTEMTIME*/, uchar &lpFormat[], uchar &lpTimeStr[], int cchTime);
 int    GetTimeFormatW(int Locale, int dwFlags, int lpTime /*SYSTEMTIME*/, string lpFormat, string lpTimeStr, int cchTime);
 int    GetTimeZoneInformation(/*TIME_ZONE_INFORMATION*/ int& TZInfoArray[17]);
        //     .
        // int gmt_shift = 0;
        // int ret = GetTimeZoneInformation(TZInfoArray);
        // if(ret != 0) gmt_shift = TZInfoArray[0];
        // Print("Difference between your local time and GMT is: ", gmt_shift, " minutes");
        // if(ret == 2) gmt_shift += TZInfoArray[42];
        // Print("Current difference between your local time and GMT is: ", gmt_shift, " minutes");
        //  (Year  ).
        // int Year  = TZInfoArray[17] & 0x0000FFFF;
        // int Month = TZInfoArray[17] >> 16;
        // int Day   = TZInfoArray[18] >> 16;
        // int Hour  = TZInfoArray[19] & 0x0000FFFF;
        // int Min   = TZInfoArray[19] >> 16;
        // int Sec   = TZInfoArray[20] & 0x0000FFFF;
        //  (Year  ).
        // int Year  = TZInfoArray[38] & 0x0000FFFF;
        // int Month = TZInfoArray[38] >> 16;
        // int Day   = TZInfoArray[39] >> 16;
        // int Hour  = TZInfoArray[40] & 0x0000FFFF;
        // int Min   = TZInfoArray[40] >> 16;
        // int Sec   = TZInfoArray[41] & 0x0000FFFF;
 int    GetUserDefaultLangID();
 int    GetUserDefaultLCID();
 int    GetVersion();
 int    GetVersionExA(int lpVersionInformation /*OSVERSIONINFO*/);
 int    GetVersionExW(int lpVersionInformation /*OSVERSIONINFO*/);
 int    GetVolumeInformationA(uchar &lpRootPathName[], uchar &lpVolumeNameBuffer[], int nVolumeNameSize, int lpVolumeSerialNumber, int lpMaximumComponentLength, int lpFileSystemFlags, uchar &lpFileSystemNameBuffer[], int nFileSystemNameSize);
 int    GetVolumeInformationW(string lpRootPathName, string lpVolumeNameBuffer, int nVolumeNameSize, int lpVolumeSerialNumber, int lpMaximumComponentLength, int lpFileSystemFlags, string lpFileSystemNameBuffer, int nFileSystemNameSize);
 int    GetWindowsDirectoryA(uchar &lpBuffer[], int nSize);
 int    GetWindowsDirectoryW(string lpBuffer, int nSize);
 int    GlobalAddAtomA(uchar &lpString[]);
 int    GlobalAddAtomW(string lpString);
 int    GlobalAlloc(int wFlags, int dwBytes);
 int    GlobalCompact(int dwMinFree);
 int    GlobalDeleteAtom(int nAtom);
 string GlobalFindAtomA(uchar &lpString[]);
 string GlobalFindAtomW(string lpString);
 void   GlobalFix(int hMem);
 int    GlobalFlags(int hMem);
 int    GlobalFree(int hMem);
 int    GlobalGetAtomNameA(int nAtom, uchar &lpBuffer[], int nSize);
 int    GlobalGetAtomNameW(int nAtom, string lpBuffer, int nSize);
 int    HeapAlloc(int hHeap, int dwFlags, int dwBytes);
 int    HeapCompact(int hHeap, int dwFlags);
 int    HeapCreate(int flOptions, int dwInitialSize, int dwMaximumSize);
 int    HeapDestroy(int hHeap);
 int    HeapFree(int hHeap, int dwFlags, string lpMem /*VARIANT*/);
 int    HeapLock(int hHeap);
 int    HeapReAlloc(int hHeap, int dwFlags, string lpMem /*VARIANT*/, int dwBytes);
 int    HeapSize(int hHeap, int dwFlags, string lpMem /*VARIANT*/);
 int    HeapUnlock(int hHeap);
 int    HeapValidate(int hHeap, int dwFlags, string lpMem /*VARIANT*/);
 int    ImpersonateLoggedOnUser(int hToken);
 int    InitAtomTable(int nSize);
 void   InitializeCriticalSection(int lpCriticalSection /*CRITICAL_SECTION*/);
 int    InterlockedDecrement(int lpAddend);
 int    InterlockedExchange(int Target, int Value);
 int    InterlockedIncrement(int lpAddend);
 int    IsBadCodePtr(int lpfn);
 int    IsBadHugeReadPtr(string lp /*VARIANT*/, int ucb);
 int    IsBadHugeWritePtr(string lp /*VARIANT*/, int ucb);
 int    IsBadReadPtr(string lp /*VARIANT*/, int ucb);
 int    IsBadStringPtrA(uchar &lpsz[], int ucchMax);
 int    IsBadStringPtrW(string lpsz, int ucchMax);
 int    IsBadWritePtr(string lp /*VARIANT*/, int ucb);
 int    IsDBCSLeadByte(int bTestChar /*Byte*/);
 int    LCMapStringA(int Locale, int dwMapFlags, uchar &lpSrcStr[], int cchSrc, uchar &lpDestStr[], int cchDest);
 int    LCMapStringW(int Locale, int dwMapFlags, string lpSrcStr, int cchSrc, string lpDestStr, int cchDest);
 void   LeaveCriticalSection(int lpCriticalSection /*CRITICAL_SECTION*/);
 int    LoadLibraryA(uchar &lpLibFileName[]);
 int    LoadLibraryW(string lpLibFileName);
 int    LoadLibraryExA(uchar &lpLibFileName[], int hFile, int dwFlags);
 int    LoadLibraryExW(string lpLibFileName, int hFile, int dwFlags);
 int    LoadModule(uchar &lpModuleName[], int lpParameterBlock /*VARIANT*/);
 int    LoadResource(int hInstance, int hResInfo);
 int    LocalAlloc(int wFlags, int wBytes);
 int    LocalCompact(int uMinFree);
 int    LocalFileTimeToFileTime(int lpLocalFileTime /*FILETIME*/, int lpFileTime /*FILETIME*/);
 int    LocalFlags(int hMem);
 int    LocalFree(int hMem);
 int    LocalHandle(int wMem /*VARIANT*/);
 int    LocalLock(int hMem);
 int    LocalReAlloc(int hMem, int wBytes, int wFlags);
 int    LocalShrink(int hMem, int cbNewSize);
 int    LocalSize(int hMem);
 int    LocalUnlock(int hMem);
 int    LockFile(int hFile, int dwFileOffsetLow, int dwFileOffsetHigh, int nNumberOfBytesToLockLow, int nNumberOfBytesToLockHigh);
 int    LockFileEx(int hFile, int dwFlags, int dwReserved, int nNumberOfBytesToLockLow, int nNumberOfBytesToLockHigh, int lpOverlapped /*OVERLAPPED*/);
 int    LockResource(int hResData);
 int    LogonUserA(uchar &lpszUsername[], uchar &lpszDomain[], uchar &lpszPassword[], int dwLogonType, int dwLogonProvider, int phToken);
 int    LogonUserW(string lpszUsername, string lpszDomain, string lpszPassword, int dwLogonType, int dwLogonProvider, int phToken);
 int    lstrcatA(uchar &lpString1[], uchar &lpString2[]);
 int    lstrcatW(string lpString1, string lpString2);
 int    lstrcmpA(uchar &lpString1[], uchar &lpString2[]);
 int    lstrcmpW(string lpString1, string lpString2);
 int    lstrcmpiA(uchar &lpString1[], uchar &lpString2[]);
 int    lstrcmpiW(string lpString1, string lpString2);
 int    lstrcpyA(uchar &lpString1[], uchar &lpString2[]);
 int    lstrcpyW(string lpString1, string lpString2);
 int    lstrcpynA(uchar &lpString1[], uchar &lpString2[], int iMaxLength);
 int    lstrcpynW(string lpString1, string lpString2, int iMaxLength);
 int    lstrlenA(uchar &lpString[]);
 int    lstrlenW(string lpString);
 //           .
 //      ,            ,  NIL.  Pointer - . 
 int    MapViewOfFile(int hFileMappingObject,    // ()     .
                      int dwDesiredAccess,       //     .
                                                 // FILE_MAP_WRITE      -    .     CreateFileMapping    PAGE_READWRITE.
                                                 // FILE_MAP_READ       -   ,   CreateFileMapping    PAGE_READONLY  PAGE_READWRITE.
                                                 // FILE_MAP_ALL_ACCESS - ,   FILE_MAP_WRITE.
                                                 // FILE_MAP_COPY       -      ,         .
                                                 //                         CreateFileMapping    PAGE_WRITECOPY.
                      int dwFileOffsetHigh,      // 64-     map-,     0.
                      int dwFileOffsetLow,       // 64-     map-,     0.
                      int dwNumberOfBytesToMap); //       ,      0,     .
 int    MapViewOfFileEx(int hFileMappingObject, int dwDesiredAccess, int dwFileOffsetHigh, int dwFileOffsetLow, int dwNumberOfBytesToMap, int lpBaseAddress /*VARIANT*/);
 int    MoveFileA(uchar &lpExistingFileName[], uchar &lpNewFileName[]);
 int    MoveFileW(string lpExistingFileName, string lpNewFileName);
 int    MoveFileExA(uchar &lpExistingFileName[], uchar &lpNewFileName[], int dwFlags);
 int    MoveFileExW(string lpExistingFileName, string lpNewFileName, int dwFlags);
 int    MulDiv(int nNumber, int nNumerator, int nDenominator);
 int    MultiByteToWideChar(int CodePage, int dwFlags, string lpMultiByteStr, int cchMultiByte, string lpWideCharStr, int cchWideChar);
// int    ObjectOpenAuditAlarmA(string SubsystemName, int HandleId /*VARIANT*/, string ObjectTypeName, string ObjectName, int pSecurityDescriptor /*SECURITY_DESCRIPTOR*/, int ClientToken, int DesiredAccess, int GrantedAccess, int Privileges /*PRIVILEGE_SET*/, int ObjectCreation, int AccessGranted, int GenerateOnClose);
 int    OpenEventA(int dwDesiredAccess, int bInheritHandle, uchar &lpName[]);
 int    OpenEventW(int dwDesiredAccess, int bInheritHandle, string lpName);
 //     .    ,      .    - HFILE_ERROR.
 int    OpenFileA(uchar &lpFileName[], int lpReOpenBuff, int wStyle);
 int    OpenFileW(string lpFileName,   //    .
    /*OFSTRUCT*/  int    lpReOpenBuff, //    OFSTRUCT,        .          OpenFile,
                                       //    .  OFSTRUCT      ,    OFS_MAXPATHNAME,  - 128 .
                                       // - ,      OpenFile,      ,   128 .  CreateFile      .
                  int    wStyle);      //  .          :
                                       // ---- . ---------------------------------------------------------------------------------------------------------------------------------------------------
                                       // OF_CANCEL           0x00000800 .  ,    ,   ,  OF_PROMPT.
                                       // OF_CREATE           0x00001000   .   ,    (0) .
                                       // OF_DELETE           0x00000200  .
                                       // OF_EXIST            0x00004000     .  ,     .
                                       // OF_PARSE            0x00000100   OFSTRUCT,    - .
                                       // OF_PROMPT           0x00002000        .    ,      ,  
                                       //                                     .    OpenFile,   --  .
                                       // OF_READ             0x00000000     .
                                       // OF_READWRITE        0x00000002    / .
                                       // OF_REOPEN           0x00008000        .
                                       // OF_SHARE_COMPAT     0x00000000    -DOS based,     ,      ,     ().
                                       //                                 ,         .      FILE_SHARE_READ|FILE_SHARE_WRITE  CreateFile.
                                       // OF_SHARE_DENY_NONE  0x00000040           .  -   DOS,   
                                       //                                     ,   .      FILE_SHARE_READ|FILE_SHARE_WRITE  CreateFile.
                                       // OF_SHARE_DENY_READ  0x00000030         .  -   DOS,     
                                       //                                ,       ,   .      FILE_SHARE_WRITE  CreateFile.
                                       // OF_SHARE_DENY_WRITE 0x00000020         .  -   DOS,     
                                       //                                ,       ,   .      FILE_SHARE_READ  CreateFile.
                                       // OF_SHARE_EXCLUSIVE  0x00000010         /    .        
                                       //                                / ,   ,   .
                                       // OF_VERIFY                      ,             .         .
                                       // OF_WRITE            0x00000001      .
 int    OpenFileMappingA(int dwDesiredAccess, int bInheritHandle, uchar &lpName[]);
 int    OpenFileMappingW(int dwDesiredAccess, int bInheritHandle, string lpName);
 int    OpenMutexA(int dwDesiredAccess, int bInheritHandle, uchar &lpName[]);
 int    OpenMutexW(int dwDesiredAccess, int bInheritHandle, string lpName);
 int    OpenProcess(int dwDesiredAccess, int bInheritHandle, int dwProcessId);
 int    OpenSemaphoreA(int dwDesiredAccess, int bInheritHandle, uchar &lpName[]);
 int    OpenSemaphoreW(int dwDesiredAccess, int bInheritHandle, string lpName);
 void   OutputDebugStringA(uchar &lpOutputString[]);
 void   OutputDebugStringW(string lpOutputString);
 int    PeekNamedPipe(int hNamedPipe, int lpBuffer /*VARIANT*/, int nBufferSize, int lpBytesRead, int lpTotalBytesAvail, int lpBytesLeftThisMessage);
 int    PrepareTape(int hDevice, int dwOperation, int bimmediate);
 int    PulseEvent(int hEvent);
 int    ReadConsoleOutputAttribute(int hConsoleOutput, int lpAttribute, int nLength, int dwReadCoord /*COORD*/, int lpNumberOfAttrsRead);
 int    ReadConsoleOutputCharacterA(int hConsoleOutput, uchar &lpCharacter[], int nLength, int dwReadCoord /*COORD*/, int lpNumberOfCharsRead);
 int    ReadConsoleOutputCharacterW(int hConsoleOutput, string lpCharacter, int nLength, int dwReadCoord /*COORD*/, int lpNumberOfCharsRead);
 //     .     TRUE,  FALSE.
 int    ReadFile(int  hFile,                 //  .
     /*VARIANT*/ int  lpBuffer,              //    .      .
                 int  nNumberOfBytesToRead,  //    .
                 int &lpNumberOfBytesRead[], //  ,          hFile.
                                             // ReadFile            .
                                             //  NULL      -  ,     .
                                             //     NULL   lpOverlapped   NULL.
  /*OVERLAPPED*/ int  lpOverlapped);         //   OVERLAPPED     hFile   FILE_FLAG_OVERLAPPED,       NULL.
                                             //  hFile  FILE_FLAG_OVERLAPPED, lpOverlapped        OVERLAPPED ,
                                             //       ,    .
                                             //  hFile,    ,     ,        ,
                                             //       .     Offset  OffsetHigh OVERLAPPED .
                                             //  hFile,     , Offset  OffsetHigh .
 int    ReadFileEx(int hFile, int lpBuffer /*VARIANT*/, int nNumberOfBytesToRead, int lpOverlapped /*OVERLAPPED*/, int lpCompletionRoutine);
 int    ReadProcessMemory(int hProcess, int lpBaseAddress, uchar &lpBuffer[], int nSize, int &lpNumberOfBytesRead[]);
 int    ReadProcessMemory(int hProcess, int lpBaseAddress, string lpBuffer, int nSize, int &lpNumberOfBytesRead[]);
 int    ReadProcessMemory(int hProcess, int lpBaseAddress, short &lpBuffer[], int nSize, int &lpNumberOfBytesRead[]);
 int    ReadProcessMemory(int hProcess, int lpBaseAddress, ushort &lpBuffer[], int nSize, int &lpNumberOfBytesRead[]);
 int    ReadProcessMemory(int hProcess, int lpBaseAddress, int &lpBuffer[], int nSize, int &lpNumberOfBytesRead[]);
 int    ReadProcessMemory(int hProcess, int lpBaseAddress, uint &lpBuffer[], int nSize, int &lpNumberOfBytesRead[]);
 int    ReadProcessMemory(int hProcess, int lpBaseAddress, long &lpBuffer[], int nSize, int &lpNumberOfBytesRead[]);
 int    ReadProcessMemory(int hProcess, int lpBaseAddress, ulong &lpBuffer[], int nSize, int &lpNumberOfBytesRead[]);
 int    ReadProcessMemory(int hProcess, int lpBaseAddress, float &lpBuffer[], int nSize, int &lpNumberOfBytesRead[]);
 int    ReadProcessMemory(int hProcess, int lpBaseAddress, double &lpBuffer[], int nSize, int &lpNumberOfBytesRead[]);
 
 
 int    ReleaseMutex(int hMutex);
 int    ReleaseSemaphore(int hSemaphore, int lReleaseCount, int lpPreviousCount);
 int    RemoveDirectoryA(uchar &lpPathName[]);
 int    RemoveDirectoryW(string lpPathName);
 int    ResetEvent(int hEvent);
 int    ResumeThread(int hThread);
 void   RtlCopyMemory(int &Destination[] /*VARIANT*/, int &Source[] /*VARIANT*/, int Length);
 void   RtlMoveMemory(int &Destination[] /*VARIANT*/, int &Source[] /*VARIANT*/, int Length);
 //       .    ,   -   ,  TCHARs,   ,     (-).
 //      nBufferLength,   -  , ,   
 int    SearchPathA(uchar &lpPath[],      //  .
                    uchar &lpFileName[],  //  .
                    uchar &lpExtension[], //  .
                    int    nBufferLength, //  .
                    uchar &lpBuffer[],    //    .
                    int    lpFilePart);   //  .
 int    SetCommBreak(int nCid);
 int    SetCommConfig(int hCommDev, int lpCC /*COMMCONFIG*/, int dwSize);
 int    SetCommMask(int hFile, int dwEvtMask);
 int    SetCommState(int hCommDev, int lpDCB /*DCB*/);
 int    SetCommTimeouts(int hFile, int lpCommTimeouts /*COMMTIMEOUTS*/);
 int    SetComputerNameA(uchar &lpComputerName[]);
 int    SetComputerNameW(string lpComputerName);
 int    SetConsoleActiveScreenBuffer(int hConsoleOutput);
 int    SetConsoleCP(int wCodePageID);
 int    SetConsoleCtrlHandler(int HandlerRoutine, int Add);
 int    SetConsoleCursorInfo(int hConsoleOutput, int lpConsoleCursorInfo /*CONSOLE_CURSOR_INFO*/);
 int    SetConsoleCursorPosition(int hConsoleOutput, int dwCursorPosition /*COORD*/);
 int    SetConsoleMode(int hConsoleHandle, int dwMode);
 int    SetConsoleOutputCP(int wCodePageID);
 int    SetConsoleScreenBufferSize(int hConsoleOutput, int dwSize /*COORD*/);
 int    SetConsoleTextAttribute(int hConsoleOutput, int wAttributes);
 int    SetConsoleTitleA(string lpConsoleTitle);
 int    SetConsoleTitleW(string lpConsoleTitle);
 int    SetConsoleWindowInfo(int hConsoleOutput, int bAbsolute, int lpConsoleWindow /*SMALL_RECT*/);
 int    SetCurrentDirectoryA(uchar &lpPathName[]);
 int    SetCurrentDirectoryW(string lpPathName);
 int    SetDefaultCommConfigA(uchar &lpszName[], int lpCC /*COMMCONFIG*/, int dwSize);
 int    SetDefaultCommConfigW(string lpszName, int lpCC /*COMMCONFIG*/, int dwSize);
 int    SetEndOfFile(int hFile);
 int    SetEnvironmentVariableA(uchar &lpName[], uchar &lpValue[]);
 int    SetEnvironmentVariableW(string lpName, string lpValue);
 int    SetErrorMode(int wMode);
 int    SetEvent(int hEvent);
 void   SetFileApisToANSI();
 void   SetFileApisToOEM();
 int    SetFileAttributesA(uchar &lpFileName[], int dwFileAttributes);
 int    SetFileAttributesW(string lpFileName, int dwFileAttributes);
 //   .   ,         (-1).
 int    SetFilePointer(int hFile,                //  .
                       int lDistanceToMove,      //          32-  NULL.
                       int lpDistanceToMoveHigh, //          32- 64-    NULL.
                       int dwMoveMethod);        //    . 0 - FILE_BEGIN      ;
                                                 //                                      1 - FILE_CURRENT    ;
                                                 //                                      2 - FILE_END        .
 int    SetFileTime(int hFile, int lpCreationTime /*FILETIME*/, int lpLastAccessTime /*FILETIME*/, int lpLastWriteTime /*FILETIME*/);
 int    SetLocaleInfoA(int Locale, int LCType, uchar &lpLCData[]);
 int    SetLocaleInfoW(int Locale, int LCType, string lpLCData);
 int    SetLocalTime(int lpSystemTime /*SYSTEMTIME*/);
 int    SetMailslotInfo(int hMailslot, int lReadTimeout);
 int    SetNamedPipeHandleState(int hNamedPipe, int lpMode, int lpMaxCollectionCount, int lpCollectDataTimeout);
 int    SetPriorityClass(int hProcess, int dwPriorityClass);
 int    SetProcessShutdownParameters(int dwLevel, int dwFlags);
 int    SetProcessWorkingSetSize(int hProcess, int dwMinimumWorkingSetSize, int dwMaximumWorkingSetSize);
 int    SetStdHandle(int nStdHandle, int nHandle);
 int    SetSystemPowerState(int fSuspend, int fForce);
 int    SetSystemTime(int lpSystemTime /*SYSTEMTIME*/);
 int    SetSystemTimeAdjustment(int dwTimeAdjustment, int bTimeAdjustmentDisabled);
 int    SetTapeParameters(int hDevice, int dwOperation, int lpTapeInformation /*VARIANT*/);
 int    SetTapePosition(int hDevice, int dwPositionMethod, int dwPartition, int dwOffsetLow, int dwOffsetHigh, int bimmediate);
 int    SetThreadAffinityMask(int hThread, int dwThreadAffinityMask);
 int    SetThreadContext(int hThread, int lpContext /*CONTEXT*/);
 int    SetThreadLocale(int Locale);
 int    SetThreadPriority(int hThread, int nPriority);
 int    SetTimeZoneInformation(int lpTimeZoneInformation /*TIME_ZONE_INFORMATION*/);
 int    SetUnhandledExceptionFilter(int lpTopLevelExceptionFilter);
 int    SetupComm(int hFile, int dwInQueue, int dwOutQueue);
 int    SetVolumeLabelA(uchar &lpRootPathName[], uchar &lpVolumeName[]);
 int    SetVolumeLabelW(string lpRootPathName, string lpVolumeName);
 int    SuspendThread(int hThread);
 int    SystemTimeToFileTime(int lpSystemTime /*SYSTEMTIME*/, int lpFileTime /*FILETIME*/);
 int    SystemTimeToTzSpecificLocalTime(int lpTimeZoneInformation /*TIME_ZONE_INFORMATION*/, int lpUniversalTime /*SYSTEMTIME*/, int lpLocalTime /*SYSTEMTIME*/);
 int    TerminateProcess(int hProcess, int uExitCode);
 int    TerminateThread(int hThread, int dwExitCode);
 int    TlsAlloc();
 int    TlsFree(int dwTlsIndex);
 int    TlsGetValue(int dwTlsIndex);
 int    TlsSetValue(int dwTlsIndex, int lpTlsValue /*VARIANT*/);
 int    TransactNamedPipe(int hNamedPipe, int lpInBuffer /*VARIANT*/, int nInBufferSize, int lpOutBuffer /*VARIANT*/, int nOutBufferSize, int lpBytesRead, int lpOverlapped /*OVERLAPPED*/);
 int    TransmitCommChar(int nCid, int cChar /*Byte*/);
 int    UnhandledExceptionFilter(int ExceptionInfo /*EXCEPTION_POINTERS*/);
 int    UnlockFile(int hFile, int dwFileOffsetLow, int dwFileOffsetHigh, int nNumberOfBytesToUnlockLow, int nNumberOfBytesToUnlockHigh);
 int    UnlockFileEx(int hFile, int dwReserved, int nNumberOfBytesToUnlockLow, int nNumberOfBytesToUnlockHigh, int lpOverlapped /*OVERLAPPED*/);
 //       .  ,       TRUE,  FALSE.
 int    UnmapViewOfFile(int lpBaseAddress /*VARIANT*/); //       ,   MapViewOfFile.
 int    UpdateResourceA(int hUpdate, uchar &lpType[], uchar &lpName[], int wLanguage, int lpData /*VARIANT*/, int cbData);
 int    UpdateResourceW(int hUpdate, string lpType, string lpName, int wLanguage, int lpData /*VARIANT*/, int cbData);
 int    VerLanguageNameA(int wLang, uchar &szLang[], int nSize);
 int    VerLanguageNameW(int wLang, string szLang, int nSize);
 int    VirtualAlloc(int lpAddress, int dwSize, int flAllocationType, int flProtect);
 int    VirtualFree(int lpAddress, int dwSize, int dwFreeType);
 int    WaitCommEvent(int hFile, int lpEvtMask, int lpOverlapped /*OVERLAPPED*/);
 int    WaitForMultipleObjects(int nCount, int lpHandles, int bWaitAll, int dwMilliseconds);
 int    WaitForMultipleObjectsEx(int nCount, int lpHandles, int bWaitAll, int dwMilliseconds, int bAlertable);
 int    WaitForSingleObject(int hHandle, int dwMilliseconds);
 int    WaitForSingleObjectEx(int hHandle, int dwMilliseconds, int bAlertable);
 int    WaitNamedPipeA(uchar &lpNamedPipeName[], int nTimeOut);
 int    WaitNamedPipeW(string lpNamedPipeName, int nTimeOut);
 int    WideCharToMultiByte(int CodePage, int dwFlags, string lpWideCharStr, int cchWideChar, string lpMultiByteStr, int cchMultiByte, string lpDefaultChar, int lpUsedDefaultChar);
 //   .          16-  .     CreateProcess.
 //  : 0                         .
 //                        ERROR_BAD_FORMAT		 .EXE   (-Win32 .EXE     .EXE ).
 //                        ERROR_FILE_NOT_FOUND	    .
 //                        ERROR_PATH_NOT_FOUND	    .
 // Pfdthiftn   : WinExec('taskkill /F /IM .exe', SW_HIDE);
 int    WinExec(string lpCmdLine, //    .
                int    nCmdShow); //    .
                                  // SW_FORCEMINIMIZE     Windows 2000/XP:  ,   ,   , .           .
 	                                // SW_HIDE                   .
   	                              // SW_MAXIMIZE            .
                                  // SW_MINIMIZE                    Z-.
                                  // SW_RESTORE                .     ,        .
                                  //                               .
                                  // SW_SHOW                         .
                                  // SW_SHOWDEFAULT         ,    SW_,    STARTUPINFO,    CreateProcess ,    .
                                  // SW_SHOWMAXIMIZED            .
                                  // SW_SHOWMINIMIZED            .
                                  // SW_SHOWMINNOACTIVE         .      SW_SHOWMINIMIZED,  ,   .
                                  // SW_SHOWNA                     .      SW_SHOW,  ,   . 
                                  // SW_SHOWNOACTIVATE            .      SW_SHOWNORMAL,  ,   . 
                                  // SW_SHOWNORMAL           .     ,        .
                                  //                               .
 //            . 	   ,    .
 int   WriteConsoleA(int hConsoleOutput, uchar &lpBuffer[], int nNumberOfCharsToWrite, int &lpNumberOfCharsWritten, int lpReserved);
 int   WriteConsoleW(int    hConsoleOutput,         //     .      GENERIC_WRITE.    ,       .
           /*VARIANT*/string lpBuffer,               //   ,   ,       .     64K.
                      int    nNumberOfCharsToWrite,  //  TCHAR  .
                      int   &lpNumberOfCharsWritten, //   ,      TCHAR.
           /*VARIANT*/int    lpReserved);            // .   (NULL).
 //     .     TRUE,  FALSE.
 int   WriteFile(int  hFile,                    //  .
      /*VARIANT*/int  lpBuffer,                 //   .      .
                 int  nNumberOfBytesToWrite,    //  ,     .
                 int &lpNumberOfBytesWritten[], //  ,          hFile.
                                                // WriteFile            .
                                                //  NULL      -  ,     .
                                                //     NULL   lpOverlapped   NULL.
                 int  lpOverlapped);            //   OVERLAPPED     hFile   FILE_FLAG_OVERLAPPED,        NULL.
                                                //  hFile,    ,     ,        ,
                                                //       .     Offset  OffsetHigh OVERLAPPED .
                                                //  hFile,     , Offset  OffsetHigh .
                                                //  ,     ,  Offset  OffsetHigh OVERLAPPED   0xFFFFFFFF.
                                                //  -  ,     CreateFile,   hFile,   FILE_APPEND_DATA.
 //    FileName   p    ,      lpString.
 int    WritePrivateProfileStringA(uchar &lpSectionName[], uchar &lpKeyName[], uchar &lpString[], uchar &lpFileName[]);
 int    WritePrivateProfileStringW(string lpSectionName, //  .   p   FileName.
                                   string lpKeyName,     //  .
                                   string lpString,      //   .
                                   string lpFileName);   //   .
 int    WriteProcessMemory(int hProcess, int lpBaseAddress, uchar &lpBuffer[], int nSize, int &lpNumberOfBytesWritten[]);
 int    WriteProcessMemory(int hProcess, int lpBaseAddress, string lpBuffer, int nSize, int &lpNumberOfBytesWritten[]);
 int    WriteProcessMemory(int hProcess, int lpBaseAddress, short &lpBuffer[], int nSize, int &lpNumberOfBytesWritten[]);
 int    WriteProcessMemory(int hProcess, int lpBaseAddress, ushort &lpBuffer[], int nSize, int &lpNumberOfBytesWritten[]);
 int    WriteProcessMemory(int hProcess, int lpBaseAddress, int &lpBuffer[], int nSize, int &lpNumberOfBytesWritten[]);
 int    WriteProcessMemory(int hProcess, int lpBaseAddress, uint &lpBuffer[], int nSize, int &lpNumberOfBytesWritten[]);
 int    WriteProcessMemory(int hProcess, int lpBaseAddress, long &lpBuffer[], int nSize, int &lpNumberOfBytesWritten[]);
 int    WriteProcessMemory(int hProcess, int lpBaseAddress, ulong &lpBuffer[], int nSize, int &lpNumberOfBytesWritten[]);
 int    WriteProcessMemory(int hProcess, int lpBaseAddress, float &lpBuffer[], int nSize, int &lpNumberOfBytesWritten[]);
 int    WriteProcessMemory(int hProcess, int lpBaseAddress, double &lpBuffer[], int nSize, int &lpNumberOfBytesWritten[]);
 int    WriteTapemark(int hDevice, int dwTapemarkType, int dwTapemarkCount, int bimmediate);
#import
//